VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
END
Attribute VB_Name = "MyDictionary"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit

'############## MyDictionary ########################################################################################
'#                                                                                                                  #
'# Copyright:   Volkswagen Aktiengesellschaft 2012                                                                  #
'# Creator:     Henry Schneider (ehenry3)           Abteilung:  K-SIPE-2/2                                          #
'# Date:        2012-07-17                          Version:    0.1.3.0                                             #
'# Autors:      Henry Schneider (ehenry3)           henry.schneider(at)autovision-gmbh.com                          #
'#              Henry Schneider (HoBLila)           lila(at)lilashome.de                                            #
'#                                                                                                                  #
'# Description: Soll eine hnliche Klasse, wie das Scription.Dictionary zur Verfgung stellen.                      #
'#              Es handelt sich dabei um ein Array mit Keys, welches Objekte aufnimmt, die man                      #
'#              dynamisch hinzufgen und lschen kann.                                                              #
'#              Ich bitte alle, die diese Klasse verbessern, ihre nderungen auch zu teilen.                        #
'#                                                                                                                  #
'# Changes:                                                                                                         #
'#      2012-07-27 ehenry3                                                                                          #
'#          removeAll():                                                                                            #
'#              - Erase-Kommando eingefgt                                                                          #
'#          remove():                                                                                               #
'#              - Objektberprfung eingebaut, da die Arrays im Skript unbestimtm sein werden                       #
'#      2012-08-17 ehenry3                                                                                          #
'#          itemByNumber():                                                                                         #
'#              - Vor dem Setzen der Rckgabe eine berprfung auf Object eingebaut, da es sonst zu Fehlern fhren  #
'#                kann                                                                                              #
'#          item():                                                                                                 #
'#              - um Objektmethoden erweitert                                                                       #
'#      2012-08-20 ehenry3                                                                                          #
'#          Gerst fr Sortierfunktion hinzugefgt                                                                  #
'#                                                                                                                  #
'# License:     Copyright (C) 2012  Volkswagen Aktiengesellschaft                                                   #
'#                                                                                                                  #
'#              This program is free software; you can redistribute it and/or modify it under the terms             #
'#              of the GNU General Lesser Public License as published by the Free Software Foundation;              #
'#              either version 3 of the License, or (at your option) any later version.                             #
'#                                                                                                                  #
'#              This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY;           #
'#              without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.           #
'#              See the GNU Lesser General Public License for more details.                                         #
'#                                                                                                                  #
'#              You should have received a copy of the GNU Lesser General Public License along with this program;   #
'#              if not, see <http://www.gnu.org/licenses/>.                                                         #
'#                                                                                                                  #
'####################################################################################################################

Private m_arrSKeys()        As String                               ' Liste der benutzten Keys
Private m_arrVarValues()    As Variant                              ' Liste der zugeordneten Objekte
Private m_boolIsSort        As Boolean                              ' Wird gesetzt, wenn Liste sortiert ist
Private m_lCount            As Long                                 ' Anzahl enthaltender Elemente

' Konstruktor
Private Sub Class_Initialize()

    m_lCount = 0

End Sub

' Methode zum Hinzufgen von neuen Elementen
Public Function add(ByVal i_sKey As String, ByRef i_varValue As Variant) As Boolean
    
    add = False
    
    ' Wenn Key schon existiert, dann raus
    If (Me.exists(i_sKey) = True) Then Exit Function
    
    ' Arrays um eins erweitern
    ReDim Preserve m_arrSKeys(m_lCount)
    ReDim Preserve m_arrVarValues(m_lCount)
    m_arrSKeys(m_lCount) = i_sKey
    If (IsObject(i_varValue)) Then
        Set m_arrVarValues(m_lCount) = i_varValue
    Else
        m_arrVarValues(m_lCount) = i_varValue
    End If
    
    m_lCount = m_lCount + 1
    
    add = True
    m_boolIsSort = False

End Function

' Methode zum Entfernen von Elementen
' der Key-Name wird bergben
Public Sub remove(ByRef i_sKey As String)

    Dim arrSBuffer()    As String
    Dim arrVarBuffer()  As Variant
    Dim lItem           As Long
    Dim lItemAdd        As Long
    Dim lUBound         As Long
    
    ' Wenn Key nicht existiert, dann raus
    If (Me.exists(i_sKey) = False) Then Exit Sub
    
    ' Anzahl Eintrge ermitteln
    lUBound = Me.count - 1
    
    ' Puffer festlegen
    ReDim arrSBuffer(lUBound)
    ReDim arrVarBuffer(lUBound)
    
    ' Alte-Werte ohne Eintrag in den Puffer schreiben
    lItemAdd = 0
    For lItem = 0 To lUBound
    
        If (Not m_arrSKeys(lItem) = i_sKey) Then
        
            If (IsObject(m_arrVarValues(lItem))) Then
            
                Set arrVarBuffer(lItemAdd) = m_arrVarValues(lItem)
                
            Else
            
                arrVarBuffer(lItemAdd) = m_arrVarValues(lItem)
            
            End If
            
            arrSBuffer(lItemAdd) = m_arrSKeys(lItem)
            lItemAdd = lItemAdd + 1
            
        End If
    
    Next lItem
    
    ' Puffer in Array-Values zurckschreiben
    m_arrVarValues = arrVarBuffer
    ' Puffer in Array-Values zurckschreiben
    m_arrSKeys = arrSBuffer
    ' Count runterzhlen
    m_lCount = m_lCount - 1

End Sub

' methode um alle Elemente zu entfernen
Public Sub removeAll()
    m_lCount = 0
'    On Error Resume Next
'        ReDim m_arrSKeys(-1)
'        ReDim m_arrVarValues(-1)
'    On Error GoTo 0
    Erase m_arrSKeys
    Erase m_arrVarValues
End Sub

' Methode um zu berprfen ob ein Key bereits existiert
Public Function exists(ByRef i_sKeyName As String) As Boolean

    Dim varSKeyWork    As Variant
    
    exists = False
    
    If (Me.count > 0) Then
    
        For Each varSKeyWork In m_arrSKeys
        
            If (varSKeyWork = i_sKeyName) Then
            
                exists = True
                Exit For
            
            End If
        
        Next varSKeyWork

    End If
    
End Function

' Methode um die Anzahl der Elemente zu ermitteln
Public Property Get count() As Long

'    On Error Resume Next
'        count = UBound(m_arrSKeys)
'        If (Not Err.Number = 0) Then count = 0
'    On Error GoTo 0
    count = m_lCount
    
End Property

' Methode um ein Element, dessen Key bekannt ist, zu erhalten
Public Function item(ByVal i_sKey As String) As Variant

    Dim lCount  As Long
    Dim lItem   As Long

    item = vbNullString
    lCount = Me.count
    
    If (lCount > 0) Then
    
        For lItem = 0 To lCount - 1
        
            If (i_sKey = m_arrSKeys(lItem)) Then
            
                If (IsObject(m_arrVarValues(lItem))) Then
                    
                    Set item = m_arrVarValues(lItem)
                    
                Else
                
                    item = m_arrVarValues(lItem)
                    
                End If
                
                Exit For
            
            End If
        
        Next lItem
    
    End If

End Function

' Methode um ein Element, dessen Nummer bekannt ist, zu erhalten
Public Function itemByNumber(ByVal i_lItem As Long) As Variant

    If (i_lItem <= m_lCount) Then
    
        If (IsObject(m_arrVarValues(i_lItem)) = True) Then
            Set itemByNumber = m_arrVarValues(i_lItem)
        Else
            itemByNumber = m_arrVarValues(i_lItem)
        End If
        
    Else
    
        Set itemByNumber = Nothing
        
    End If
    
End Function

' Methode um den Namen eines Keys zu ndern
Public Function changeKeyName(ByRef i_sOldKeyName As String, ByRef i_sNewKeyName As String) As Boolean

    changeKeyName = False
    
    If (Me.exists(i_sNewKeyName)) Then Exit Function
    
    Dim lCount  As Long
    Dim lItem   As Long

    item = vbNullString
    lCount = Me.count
    
    If (lCount > 0) Then
    
        For lItem = 0 To lCount - 1
        
            If (i_sOldKeyName = m_arrSKeys(lItem)) Then
            
                m_arrSKeys(lItem) = i_sOldKeyName
                changeKeyName = True
                Exit For
            
            End If
        
        Next lItem
    
    End If
    
    m_boolIsSort = False

End Function

' Methode um alle Keys, als Liste zu erhalten
Public Function keys() As String()

    keys = m_arrSKeys

End Function

' Methode um alle Items, als Liste zu erhalten
Public Function items() As Variant()

    items = m_arrVarValues

End Function

Private Sub Class_Terminate()

    Erase m_arrSKeys
    Erase m_arrVarValues

End Sub

' Method to sort the lists alphanumeric by key
Public Sub sortABC()

    m_boolIsSort = True

End Sub
